################
# read in data
################

with open('keylog.txt') as f:
    keylog = f.readlines()
    keylog = [ line.strip() for line in keylog ]




##################################
# build the required information
##################################

# dict of num -> [num]
# e.g.  3 : [4,5,6] means 4, 5 and 6 come before 3
comes_before = {}

# hard to find a good function name here
def record_item_order(first, second):
    """Register that 'first' comes before 'second'."""
    comes_before.setdefault(first,[])
    comes_before.setdefault(second,[])
    if first not in comes_before[second]:
        comes_before[second].append(first)

# always have 3 items, so can unpack directly
for a,b,c in keylog:
    # print(a,b,c)   # useful while developing
    record_item_order(a,b)
    record_item_order(a,c)
    record_item_order(b,c)


# print(comes_before)   # useful while developing


##############################################################
# find the items in the right order, build up solution string
##############################################################

def find_empty_before():
    """
    Find the number that has no other numbers listed as coming before.
    
    There should always be one like that, so not finding one is an error.
    """
    for num, bef_list in comes_before.items():
        # print(num,bef_list)   # useful while developing
        if bef_list == []: # if not bef_list:  # if bef_list.size() == 0:
            return num
            
    assert False, "Should not get here"
    # -- or --
    # print("Should not get here")
    # exit(1)
    # -- or --
    # return None
    

# loop as long as there are numbers left in the dict
solution = ""
while comes_before: # turns False once dict is empty
    next_num = find_empty_before()
    solution += next_num
    # remove from dict, we dealt with it
    del comes_before[next_num]
    # remove from lists, makes a new empty list
    for k, v in comes_before.items():
        v.remove(next_num)

    # useful while developing
    # print(next_num)
    # print(comes_before)
    # print(solution)
    
    
#################
# present result
#################
    
print(solution)
